#ifdef TEXT_MSG
#include <stdio.h>
#endif
#include <unistd.h>
#include "Errors.h"
#include "Fct_Sys.h"
#include <sys/stat.h>
#include <sys/types.h>

/*
** give_file_size: donne la taille(en octet) du fichier presise
*/
off_t give_file_size(file)
     int file;
{
  struct stat	buf;

  if (fstat(file, &buf) == -1)
    {
#ifdef TEXT_MSG
      printf("%s\n", BAD_STAT);
#endif
      return (0);
    }
  return (buf.st_size);
}

/*
** Gives file size with its nale
*/
off_t give_file_size_by_name(file)
     char* file;
{
  struct stat	buf;

  if (lstat(file, &buf) == -1)
    {
#ifdef TEXT_MSG
      printf("%s\n", BAD_STAT);
#endif
      return (0);
    }
  return (buf.st_size);
}







