/* Just to save */


gint		draw_wav_right_basic(widget, data)
GtkWidget	*widget ;
gpointer	data ;
{
  Waveditor	*wve ;
  Wavwin	*ww ;
  GdkSegment	seg ;
  GdkRectangle	rec ;
  int 		iwidth ; /* width of the drawing area */
  int		iheight ; /* height of the drawing area */
  size_t 	begin ; /* just where to begin */
  size_t	width ;  /* size in gint16 of the piece of wave to show */
  gint32	buffer[BUF_SIZE] ; 
  union{
    gint32	num ;
    gint16	chan[2] ;
  }sample ;
  int		file ; /* file descriptor */
  size_t	rd ; /* number of bytes read during the last buffer read */
  size_t	i ; /* just a counter */
  size_t	new_i ;
  int		mid ;
  size_t	nb ;  /* number of gint16 read since start */
  size_t	nb_av ; /* number of gint16 read just before the last buffer read */  
  float		coefx ; 
  float		coefy ;  

  wve = WAVEDITOR (widget) ;
  ww = WAVWIN (data) ;
  iwidth = wve->DrawingArea[RIGHT]->allocation.width ;
  iheight = wve->DrawingArea[RIGHT]->allocation.height ;
  rec.x = 0;
  rec.y = 0;
  rec.width = iwidth ;
  rec.height = iheight ;

  gdk_draw_rectangle (wve->pixmap[RIGHT],
		      wve->DrawingArea[RIGHT]->style->black_gc,
		      TRUE,
		      0, 0,
		      iwidth, iheight);

  begin = wve->part_watched.x ;
  width = wve->part_watched.y  - wve->part_watched.x ;
  if (ww->tempgmurf->file != -1){
    file = ww->tempgmurf->file ;
    coefx = (float) (width) / (float) iwidth ;
    coefy = (float) (iheight / 2 -1) / (float) MAX_16BITS ;
    nb = begin ;
    nb_av = nb ;
    lseek(file, nb * 4, SEEK_SET) ;
    nb +=  (rd = read(file, buffer, BUF_SIZE*4))/4 ;
    mid = iheight /2 -1 ;
    for (i = 0; i < iwidth; i ++){
      seg.x2 = seg.x1 = i ;
      new_i = (int) ( (float) i * coefx ) + begin;
      if (new_i > nb)
	while ((rd != 0) && (new_i > nb)){
	  nb_av = nb ;
	  nb += (rd = read(file, buffer, BUF_SIZE*4)) / 4 ;
	}
      
      sample.num = buffer[new_i - nb_av] ;
      seg.y1 = mid - sample.chan[RIGHT] * coefy ;
      seg.y2 = mid + sample.chan[RIGHT] * coefy ;
      gdk_draw_segments(wve->pixmap[RIGHT],
			wve->DrawingArea[RIGHT]->style->white_gc,
			&seg, 1) ;
    }
  }
  gtk_widget_draw(wve->DrawingArea[RIGHT], &rec);
  return TRUE ;
}



gint		draw_wav_right_sinus(widget, data)
GtkWidget	*widget ;
gpointer	data ;
{
  Waveditor	*wve ;
  Wavwin	*ww ;
  GdkSegment	seg ;
  GdkRectangle	rec ;
  int 		iwidth ; /* width of the drawing area */
  int		iheight ; /* height of the drawing area */
  size_t 	begin ; /* just where to begin */
  size_t	width ;  /* size in gint16 of the piece of wave to show */
  gint32	buffer[BUF_SIZE] ; 
  union{
    gint32	num ;
    gint16	chan[2] ;
  }sample ;
  int		file ; /* file descriptor */
  size_t	rd ; /* number of bytes read during the last buffer read */
  size_t	i ; /* just a counter */
  size_t	new_i ;
  int		mid ;
  size_t	nb ;  /* number of gint16 read since start */
  size_t	nb_av ; /* number of gint16 read just before the last buffer read */  
  float		coefx ; 
  float		coefy ;  

  wve = WAVEDITOR (widget) ;
  ww = WAVWIN (data) ;
  iwidth = wve->DrawingArea[RIGHT]->allocation.width ;
  iheight = wve->DrawingArea[RIGHT]->allocation.height ;
  rec.x = 0;
  rec.y = 0;
  rec.width = iwidth ;
  rec.height = iheight ;

  gdk_draw_rectangle (wve->pixmap[RIGHT],
		      wve->DrawingArea[RIGHT]->style->black_gc,
		      TRUE,
		      0, 0,
		      iwidth, iheight);

  begin = wve->part_watched.x ;
  width = wve->part_watched.y  - wve->part_watched.x  ;
  if (ww->tempgmurf->file != -1){
    file = ww->tempgmurf->file ;
    coefx = (float) (width) / (float) iwidth ;
    coefy = (float) (iheight / 2 -1) / (float) MAX_16BITS ;
    nb = begin ;
    nb_av = nb ;
    lseek(file, nb * 4, SEEK_SET) ;
    nb +=  (rd = read(file, buffer, BUF_SIZE*4))/4 ;
    mid = iheight /2 -1 ;
    seg.x1 = 0 ;
    seg.y1 = mid ;
    for (i = 0; i < iwidth; i ++){
      seg.x2 =  i ;
      new_i = (int) ( (float) i * coefx ) + begin;
      if (new_i > nb)
	while ((rd != 0) && (new_i > nb)){
	  nb_av = nb ;
	  nb += (rd = read(file, buffer, BUF_SIZE*4)) / 4 ;
	}
      sample.num = buffer[new_i - nb_av] ;
      seg.y2 = mid + sample.chan[RIGHT] * coefy ;
      gdk_draw_segments(wve->pixmap[RIGHT],
			wve->DrawingArea[RIGHT]->style->white_gc,
			&seg, 1) ;
      seg.y1 = seg.y2 ;
      seg.x1 = seg.x2 ;
    }
  }
  gtk_widget_draw(wve->DrawingArea[RIGHT], &rec);
  return TRUE ;
}


gint		draw_wav_left_basic(widget, data)
GtkWidget	*widget ;
gpointer	data ;
{
  Waveditor	*wve ;
  Wavwin	*ww ;
  GdkSegment	seg ;
  GdkRectangle	rec ;
  int 		iwidth ; /* width of the drawing area */
  int		iheight ; /* height of the drawing area */
  size_t 	begin ; /* just where to begin */
  size_t	width ;  /* size in gint16 of the piece of wave to show */
  gint32	buffer[BUF_SIZE] ; 
  union{
    gint32	num ;
    gint16	chan[2] ;
  }sample ;
  int		file ; /* file descriptor */
  size_t	rd ; /* number of bytes read during the last buffer read */
  size_t	i ; /* just a counter */
  size_t	new_i ;
  int		mid ;
  size_t	nb ;  /* number of gint16 read since start */
  size_t	nb_av ; /* number of gint16 read just before the last buffer read */  
  float		coefx ; 
  float		coefy ;  

  wve = WAVEDITOR (widget) ;
  ww = WAVWIN (data) ;
  iwidth = wve->DrawingArea[LEFT]->allocation.width ;
  iheight = wve->DrawingArea[LEFT]->allocation.height ;
  rec.x = 0;
  rec.y = 0;
  rec.width = iwidth ;
  rec.height = iheight ;

  gdk_draw_rectangle (wve->pixmap[LEFT],
		      wve->DrawingArea[LEFT]->style->black_gc,
		      TRUE,
		      0, 0,
		      iwidth, iheight);
  
  begin = wve->part_watched.x ;
  width = wve->part_watched.y  - wve->part_watched.x ;
  if (ww->tempgmurf->file != -1){
    file = ww->tempgmurf->file ;
    coefx = (float) (width) / (float) iwidth ;
    coefy = (float) (iheight / 2 -1) / (float) MAX_16BITS ;
    nb = begin ;
    nb_av = nb ;
    lseek(file, nb * 4, SEEK_SET) ;
    nb +=  (rd = read(file, buffer, BUF_SIZE*4))/4 ;
    mid = iheight /2 -1 ;
    for (i = 0; i < iwidth; i ++){
      seg.x2 = seg.x1 = i ;
      new_i = (int) ( (float) i * coefx ) + begin;
      if (new_i > nb)
	while ((rd != 0) && (new_i > nb)){
	  nb_av = nb ;
	  nb += (rd = read(file, buffer, BUF_SIZE*4)) / 4 ;
	}
      
      sample.num = buffer[new_i - nb_av] ;
      seg.y1 = mid + sample.chan[LEFT] * coefy ;
      seg.y2 = mid - sample.chan[LEFT] * coefy ;
      gdk_draw_segments(wve->pixmap[LEFT],
			wve->DrawingArea[LEFT]->style->white_gc,
			&seg, 1) ;
      }
  }
  gtk_widget_draw(wve->DrawingArea[LEFT], &rec);
  return TRUE ;
}



gint		draw_wav_left_sinus(widget, data)
GtkWidget	*widget ;
gpointer	data ;
{
  Waveditor	*wve ;
  Wavwin	*ww ;
  GdkSegment	seg ;
  GdkRectangle	rec ;
  int 		iwidth ; /* width of the drawing area */
  int		iheight ; /* height of the drawing area */
  size_t 	begin ; /* just where to begin */
  size_t	width ;  /* size in gint16 of the piece of wave to show */
  gint32	buffer[BUF_SIZE] ; 
  union{
    gint32	num ;
    gint16	chan[2] ;
  }sample ;
  int		file ; /* file descriptor */
  size_t	rd ; /* number of bytes read during the last buffer read */
  size_t	i ; /* just a counter */
  size_t	new_i ;
  int		mid ;
  size_t	nb ;  /* number of gint16 read since start */
  size_t	nb_av ; /* number of gint16 read just before the last buffer read */  
  float		coefx ; 
  float		coefy ;  

  wve = WAVEDITOR (widget) ;
  ww = WAVWIN (data) ;
  iwidth = wve->DrawingArea[LEFT]->allocation.width ;
  iheight = wve->DrawingArea[LEFT]->allocation.height ;
  rec.x = 0;
  rec.y = 0;
  rec.width = iwidth ;
  rec.height = iheight ;

  gdk_draw_rectangle (wve->pixmap[LEFT],
		      wve->DrawingArea[LEFT]->style->black_gc,
		      TRUE,
		      0, 0,
		      iwidth, iheight);

  begin = wve->part_watched.x ;
  width = wve->part_watched.y  - wve->part_watched.x  ;
  if (ww->tempgmurf->file != -1){
    file = ww->tempgmurf->file ;
    coefx = (float) (width) / (float) iwidth ;
    coefy = (float) (iheight / 2 -1) / (float) MAX_16BITS ;
    nb = begin ;
    nb_av = nb ;
    lseek(file, nb * 4, SEEK_SET) ;
    nb +=  (rd = read(file, buffer, BUF_SIZE*4))/4 ;
    mid = iheight /2 -1 ;
    seg.y1 = mid ;
    seg.x1 = 0 ;
    for (i = 0; i < iwidth; i ++){
      seg.x2  = i ;
      new_i = (int) ( (float) i * coefx ) + begin;
      if (new_i > nb)
	while ((rd != 0) && (new_i > nb)){
	  nb_av = nb ;
	  nb += (rd = read(file, buffer, BUF_SIZE*4)) / 4 ;
	}
      sample.num = buffer[new_i - nb_av] ;
      seg.y2 = mid + sample.chan[LEFT] * coefy ;
      gdk_draw_segments(wve->pixmap[LEFT],
			wve->DrawingArea[LEFT]->style->white_gc,
			&seg, 1) ;
    seg.y1 = seg.y2 ;
    seg.x1 = seg.x2 ;
    }
  }
  gtk_widget_draw(wve->DrawingArea[LEFT], &rec);
  return TRUE ;
}
